/*!
 * \file   utl/core/types.h
 * \brief  Basic type alias support
 */

#ifndef __utl_core_types_h__
#define __utl_core_types_h__

#include <cstddef>
#include <cstdint>

//#include <type_traits>

namespace utl {
   //! \name byte and word types
   //! @{
   using byte_t   = uint8_t;     //!< 8 bits wide
   using word_t   = uint16_t;    //!< 16 bits wide
   using dword_t  = uint32_t;    //!< 32 bits wide
   //! @}

   //! \name size and index
   //! @{
   using size_t   = std::size_t;
   using index_t  = size_t;      //!< index_t and size_t mend to be interchangeable

   using ptrdiff_t= std::ptrdiff_t;
   //! @}
}

#endif /* __utl_core_types_h__ */
